#ifndef COURSE_H
#define COURSE_H

#include <sdbus-c++/Types.h>
#include <unordered_map>
#define IMGUI_DEFINE_MATH_OPERATORS
#include <imgui.h>
#include <memory>
#include <raylib.h>
#include <sdbus-c++/IConnection.h>
#include <sdbus-c++/IProxy.h>
#include <string>
#include "cpp/quantize/celebi.h"

class RayTexture {
  public:
    Texture tex{};
    std::string path;
    RayTexture();
    explicit RayTexture(Image img);
    RayTexture(const RayTexture& other);
    RayTexture& operator=(const RayTexture& other);
    ~RayTexture();
};

class DiscObject {
public:
  float prevouspos;
  float pos;
  float velo;
  float accel;
  float target;
  bool active;
  bool enabled;
  DiscObject(float ia);
  void UpdatePos(float dtime);
  void UpdatePos(float pos, float dtime);
  void AddAccel(float ac);
  void Activate();
};


class MprisPlayer {
  public:
    std::unique_ptr<sdbus::IConnection> bus_connection;
    std::unique_ptr<sdbus::IProxy> PlayerProxy;
    sdbus::InterfaceName mp2;
    sdbus::MethodName playpause;
    RayTexture tex;
    std::vector<Color> accent_colors;
    std::string image_path_cache;
    long imagecount;
    explicit MprisPlayer(std::string servicename);
    void PausePlay();
    void Refresh();
    void UpdateTexture();
    void Next();
    void Prev();
    std::string identity;
    std::string playstate;
    std::string GetIdentity();
    std::unordered_map<std::string, sdbus::Variant> current_metadata;
    std::unordered_map<std::string, sdbus::Variant> GetCurrentMetadata();
    Color GetPrimaryColor();
};


#endif
